// -------------------------------------------------------------------------------------
// 
// ReTest.CS                                                      Ulrich Mller 11.10.05
//                                                                 PCS1700  C# Final SP2
// Rechentest-Programm mit Visualisierung der Aufgabe durch 
// deren Ausfhrung auf einem Tascherechner-Roboter
//
// Die ursprngliche Idee dazu : Betrieb eines Handies mit dem SulenRobot der
// Industry Robots stammt von Rudolf Vaum, Rumnien und wurde im 
// fischertechnik Forum vorgestellt (Okt. 2005)
// 
// Nutzung von FishFace40.DLL
//
// Belegung Interface :
// Y-Achse : M1, I1(Endtaster), I2(Impulstaster)
// X-Achse : M2, I3, I4
// Taster  : M3, I5
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFace40;


namespace RechenTest {
	public class frmMain : System.Windows.Forms.Form {
		private System.Windows.Forms.TextBox txtOP1;
		private System.Windows.Forms.TextBox txtOP2;
		private System.Windows.Forms.TextBox txtErgebnis;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkSumme;

		private FishRobot ft = new FishRobot(new int[,] {{2, 111},{1,150}});
		private System.Windows.Forms.NumericUpDown numWieder;

		// --- Tastenkoordinaten des Taschenrechners in Impulsen ab Home !! Y, X !!
		private int[,] TasPos = {{38, 6},  // 0 : Taste 0
                                 {38, 30},  // 1 : Taste 1
                                 {56, 30}, 
                                 {80, 30}, 
                                 {38, 51}, 
                                 {56, 51}, 
                                 {80, 51}, 
                                 {38, 73}, 
                                 {56, 73}, 
                                 {80, 73},  // 9 : Taste 9
                                 {56, 6},  // 10 : Dezimalkomma
                                 {80, 6},  // 11 : Taste =
                                 {105, 6}, // 12 : Addition
                                 {105, 30}, // 13 : Subtraktion
                                 {105, 51}, // 14 : Multiplikation
                                 {105, 73}, // 15 : Division
                                 {16, 51},  // 16 : Prozent
                                 {16, 73},  // 17 : Wurzel
                                 {105, 95}, // 18 : Taste +/-
                                 {16, 95}, // 19 : DeltaProzent
                                 {80, 95}, // 20 : Memory Minus
                                 {56, 95}, // 21 : Memory Plus
                                 {38, 95}, // 22 : Memory Recall/Clear
                                 {16, 30},  // 23 : Clear Entry
                                 {16, 6},  // 24 : Clear
                                 {16, 128}  // 25 : AllClear
								};

		public frmMain() {
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtOP1 = new System.Windows.Forms.TextBox();
			this.txtOP2 = new System.Windows.Forms.TextBox();
			this.txtErgebnis = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.chkSumme = new System.Windows.Forms.CheckBox();
			this.numWieder = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.numWieder)).BeginInit();
			this.SuspendLayout();
			// 
			// txtOP1
			// 
			this.txtOP1.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOP1.Location = new System.Drawing.Point(40, 40);
			this.txtOP1.Name = "txtOP1";
			this.txtOP1.Size = new System.Drawing.Size(56, 27);
			this.txtOP1.TabIndex = 0;
			this.txtOP1.Text = "27";
			this.txtOP1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtOP2
			// 
			this.txtOP2.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtOP2.Location = new System.Drawing.Point(160, 40);
			this.txtOP2.Name = "txtOP2";
			this.txtOP2.Size = new System.Drawing.Size(56, 27);
			this.txtOP2.TabIndex = 1;
			this.txtOP2.Text = "27";
			this.txtOP2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// txtErgebnis
			// 
			this.txtErgebnis.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtErgebnis.Location = new System.Drawing.Point(328, 40);
			this.txtErgebnis.Name = "txtErgebnis";
			this.txtErgebnis.Size = new System.Drawing.Size(56, 27);
			this.txtErgebnis.TabIndex = 2;
			this.txtErgebnis.Text = "???";
			this.txtErgebnis.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(120, 48);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(16, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "+";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(264, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "=";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.LightGray;
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(40, 88);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(344, 24);
			this.lblStatus.TabIndex = 5;
			this.lblStatus.Text = "Interface zuordnen und START";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdEnde.Location = new System.Drawing.Point(288, 136);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(96, 32);
			this.cmdEnde.TabIndex = 6;
			this.cmdEnde.Text = "Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdAction.Location = new System.Drawing.Point(288, 176);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(96, 32);
			this.cmdAction.TabIndex = 7;
			this.cmdAction.Text = "START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cboPortName
			// 
			this.cboPortName.Items.AddRange(new object[] {
															 "USB",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(184, 182);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(88, 21);
			this.cboPortName.TabIndex = 8;
			this.cboPortName.Text = "USB";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(48, 144);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(144, 16);
			this.label3.TabIndex = 9;
			this.label3.Text = "Anzahl Wiederholungen";
			// 
			// chkSumme
			// 
			this.chkSumme.Location = new System.Drawing.Point(48, 184);
			this.chkSumme.Name = "chkSumme";
			this.chkSumme.Size = new System.Drawing.Size(112, 16);
			this.chkSumme.TabIndex = 10;
			this.chkSumme.Text = "Summen bilden";
			// 
			// numWieder
			// 
			this.numWieder.Location = new System.Drawing.Point(200, 144);
			this.numWieder.Name = "numWieder";
			this.numWieder.Size = new System.Drawing.Size(64, 21);
			this.numWieder.TabIndex = 11;
			this.numWieder.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.numWieder.Value = new System.Decimal(new int[] {
																	1,
																	0,
																	0,
																	0});
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(406, 227);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.numWieder,
																		  this.chkSumme,
																		  this.label3,
																		  this.cboPortName,
																		  this.cmdAction,
																		  this.cmdEnde,
																		  this.lblStatus,
																		  this.label2,
																		  this.label1,
																		  this.txtErgebnis,
																		  this.txtOP2,
																		  this.txtOP1});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Name = "frmMain";
			this.Text = "FishFace40 : Rechentest";
			((System.ComponentModel.ISupportInitialize)(this.numWieder)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new frmMain());
		}

		// --- Zentrale Steuerungsroutine ----------------------------
		private void cmdAction_Click(object sender, System.EventArgs e) {
		    int OP1, OP2;                // --- num. Wert der Operanden
			int i, ptrTas, Losung;
			int[] Tasten = new int[24];  // --- Liste der anzufahrenden Tasten
			try {
				// --- START : Verbinden Interface, Anfahren Home --------
				if(cmdAction.Text == "START") {
					if(cboPortName.SelectedIndex == 0)
						ft.OpenInterface(IFTypen.ftROBO_first_USB, 0 , true);
					else ft.OpenInterface(IFTypen.ftIntelligent_IF, 
							 cboPortName.SelectedIndex, 5, true);
					cmdEnde.Text = "HALT";
					lblStatus.Text = "Fhrt auf Home Position";
					TasterGo();
					ft.MoveHome();
					ft.MoveTo(TasPos[25, 0], TasPos[25, 1]);  // --- AllClear
					TasterGo();
					lblStatus.Text = "Gestartet";
					cmdEnde.Text = "ENDE";
					cmdAction.Text = "LSUNG";
					cmdEnde.Focus();
				}
					// --- berprfen der Lsung --------------------
				else if(cmdAction.Text == "LSUNG") {
					for(int j = 0; j < numWieder.Value; j++) {
						OP1 = Convert.ToInt32(txtOP1.Text);
						OP2 = Convert.ToInt32(txtOP2.Text);
						txtErgebnis.Text = Convert.ToString(OP1 + OP2);
						// --- Bestimmen der Taschenrechnertasten -------------
						ptrTas = 0;
						Tasten[ptrTas++] = 24;             // --- Clear
						for(i = 0; i < txtOP1.Text.Length; i++)
							Tasten[ptrTas++] = Convert.ToInt32(txtOP1.Text.Substring(i, 1));
						Tasten[ptrTas++] = 12;             // --- Addition
						for(i = 0; i < txtOP2.Text.Length; i++)
							Tasten[ptrTas++] = Convert.ToInt32(txtOP2.Text.Substring(i, 1));
						Tasten[ptrTas++] = 11;             // --- Taste =
						// --- Kontrolle mit dem Taschenrechner ---------------
						cmdEnde.Text = "HALT";
						lblStatus.Text = "Kontrolle mit dem Taschenrechner";
						for(i = 0; i < ptrTas; i++) {
							if(j > 0) lblStatus.Text = "Runde : " + Convert.ToString(j+1);
							ft.MoveTo(TasPos[Tasten[i], 0], TasPos[Tasten[i], 1]);
							TasterGo();
						}
						if(chkSumme.Checked) {
							ft.MoveTo(TasPos[21, 0], TasPos[21, 1]);
							TasterGo(); // Memory+
							txtOP1.Text = Convert.ToString(OP1+1);
							txtOP2.Text = Convert.ToString(OP2-1);
						}
					}
					ft.MoveTo(0, ft.MotCntl[1].maxPos);	
					lblStatus.Text = "Bravo";
					cmdEnde.Text = "ENDE";
				}
			}
			catch(FishFaceException eft) {
				lblStatus.Text = eft.Message;
			}
			catch(Exception ee) {
				lblStatus.Text = ee.Message;
			}
		}

		// --- Ende Routine ------------------------------------------
		private void cmdEnde_Click(object sender, System.EventArgs e) {
			if(cmdEnde.Text == "HALT") ft.NotHalt = true;
			else {
				ft.CloseInterface();
				this.Close();
			}
		}
		// --- Bettigen einer Taste ----------------------------------
		private void TasterGo() {
			ft.SetMotor(Out.M3, Dir.Left);
			ft.WaitForInput(Inp.I5);
			ft.SetMotor(Out.M3, Dir.Right);
			ft.Pause(555);
			ft.SetMotor(Out.M3, Dir.Off);
		}
	}
}
